Subject: bug#31453: emacs 25.3; timezone handling broken

From: e step <[email-masked]>
Date: Mon, 14 May 2018 10:51:09 -0400

After further investigation, I think this is due to a deeper issue in glibc
(see
https://stackoverflow.com/questions/47563103/why-datetime-now-and-datetime-today-show-time-in-utc-and-not-local-time-on-m/50333163#50333163
).

So probably this is not the fault of emacs but emacs may want to work
around this issue until it gets fixed in glibc.

On Mon, May 14, 2018 at 10:36 AM, e step <[email-masked]> wrote:

>
>   1. I installed emacs 25.3_1 for Windows
>   2. From cygwin shell, I did "/c/emacs25/emacs-25.3_1-x86_64/bin/emacs.exe
> -Q"
>   3. Within emacs, I did M-: (getenv "TZ") which returned "America/New
> York".
>   4. Within emacs, I did M-: (current-time-string)
>   5. The resulting time is using incorrect time zone.
>   6. Inside cygwin, I did "export TZ=" to unset the TZ variable.
>   7. Within emacs, I did M-: (getenv "TZ") which returned nil.
>   8. Within emacs, I did M-: (current-time-string) to get correct time.
>
> My work around is to not set the TZ variable which is doable but not
> desirable.
>
>
>
> In GNU Emacs 25.3.1 (x86_64-w64-mingw32)
>  of 2017-09-26 built on LAPHROAIG
> Windowing system distributor 'Microsoft Corp.', version 10.0.17134
> Configured using:
>  'configure --without-dbus --without-compress-install 'CFLAGS=-O2
>  -static -g3' PKG_CONFIG_PATH=/mingw64/lib/pkgconfig'
>
> Configured features:
> XPM JPEG TIFF GIF PNG RSVG SOUND NOTIFY ACL GNUTLS LIBXML2 ZLIB
> TOOLKIT_SCROLL_BARS
>
> Important settings:
>   value of $LANG: en_US.UTF-8
>   locale-coding-system: cp1252
>
> Major mode: Lisp Interaction
>
> Minor modes in effect:
>   tooltip-mode: t
>   global-eldoc-mode: t
>   electric-indent-mode: t
>   mouse-wheel-mode: t
>   tool-bar-mode: t
>   menu-bar-mode: t
>   file-name-shadow-mode: t
>   global-font-lock-mode: t
>   font-lock-mode: t
>   blink-cursor-mode: t
>   auto-composition-mode: t
>   auto-encryption-mode: t
>   auto-compression-mode: t
>   line-number-mode: t
>   transient-mark-mode: t
>
> Recent messages:
> For information about GNU Emacs and the GNU system, type C-h C-a.
> "America/New_York"
> Quit
> "Mon May 14 15:28:21 2018"
>
> Load-path shadows:
> None found.
>
> Features:
> (shadow sort mail-extr emacsbug message dired format-spec rfc822 mml
> mml-sec password-cache epg epg-config gnus-util mm-decode mm-bodies
> mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail
> rfc2047 rfc2045 ietf-drums mm-util help-fns help-mode easymenu
> cl-loaddefs pcase cl-lib mail-prsvr mail-utils time-date mule-util
> tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
> mwheel dos-w32 ls-lisp disp-table w32-win w32-vars term/common-win
> tool-bar dnd fontset image regexp-opt fringe tabulated-list newcomment
> elisp-mode lisp-mode prog-mode register page menu-bar rfn-eshadow timer
> select scroll-bar mouse jit-lock font-lock syntax facemenu font-core
> frame cl-generic cham georgian utf-8-lang misc-lang vietnamese tibetan
> thai tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek romanian
> slovak czech european ethiopic indian cyrillic chinese charscript
> case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer
> cl-preloaded nadvice loaddefs button faces cus-face macroexp files
> text-properties overlay sha1 md5 base64 format env code-pages mule
> custom widget hashtable-print-readable backquote w32notify w32 multi-tty
> make-network-process emacs)
>
> Memory information:
> ((conses 16 88765 5870)
>  (symbols 56 19651 0)
>  (miscs 48 44 85)
>  (strings 32 15897 4470)
>  (string-bytes 1 440523)
>  (vectors 16 11730)
>  (vector-slots 8 424140 5367)
>  (floats 8 159 44)
>  (intervals 56 236 56)
>  (buffers 976 19))
>
>